## svxlink 19.09.1

=== src/CMakeLists.txt ===
##############################################################################
# SvxLink - A Multi Purpose Voice Services System for Ham Radio Use
# Copyright (C) 2003-2013 Tobias Blomberg / SM0SVX
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
##############################################################################

##############################################################################
# Project setup
##############################################################################
cmake_minimum_required(VERSION 2.8)
project(svxlink C CXX)
#enable_testing()

# The path to the project global include directory
set(PROJECT_INCLUDE_DIR ${PROJECT_BINARY_DIR}/include)

# Where to put library files
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

# Where to put executable files
set(RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

# Add project local CMake module directory
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# Optional parts
option(USE_QT "Build Qt applications and libs" ON)
option(BUILD_STATIC_LIBS "Build static libraries in addition to dynamic" OFF)

# The sample rate used internally in SvxLink
if(NOT DEFINED INTERNAL_SAMPLE_RATE)
  set(INTERNAL_SAMPLE_RATE 16000)
endif(NOT DEFINED INTERNAL_SAMPLE_RATE)
add_definitions(-DINTERNAL_SAMPLE_RATE=${INTERNAL_SAMPLE_RATE})

# Set up include directories
include_directories(
  ${PROJECT_INCLUDE_DIR}
  ${CMAKE_BINARY_DIR}
)

# Warnings should be enabled for GCC. Also turning off the NDEBUG flag
# since that remove asserts.
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_C_FLAGS
    "${CMAKE_C_FLAGS} -Wall -Wstrict-prototypes -Wpointer-arith")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g")

  set(CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wall -Wpointer-arith")
  set(CMAKE_CXX_FLAGS_RELEASE "-O3")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")

  option(USE_GPROF "Enable profiling" OFF)
  if(USE_GPROF)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pg")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
  endif(USE_GPROF)
endif()

# Set the default build type to Release
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)


##############################################################################
# Install targets properties setup
##############################################################################

# Set up standard GNU installation directories
include(GNUInstallDirs)

# Where to install include files
if(NOT DEFINED INCLUDE_INSTALL_DIR)
  #set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/include)
  set(INCLUDE_INSTALL_DIR ${CMAKE_INSTALL_FULL_INCLUDEDIR})
endif(NOT DEFINED INCLUDE_INSTALL_DIR)

# Where to install libraries
if(NOT DEFINED LIB_INSTALL_DIR)
  #set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
  set(LIB_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif(NOT DEFINED LIB_INSTALL_DIR)

# The config directory (normally /etc)
if(NOT DEFINED SYSCONF_INSTALL_DIR)
  #set(SYSCONF_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/etc)
  set(SYSCONF_INSTALL_DIR ${CMAKE_INSTALL_FULL_SYSCONFDIR})
endif(NOT DEFINED SYSCONF_INSTALL_DIR)

# Architecture independent files directory (normally /usr/share)
if(NOT DEFINED SHARE_INSTALL_PREFIX)
  #set(SHARE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX}/share)
  set(SHARE_INSTALL_PREFIX ${CMAKE_INSTALL_FULL_DATADIR})
endif(NOT DEFINED SHARE_INSTALL_PREFIX)

# Local state directory (normally /var)
if(NOT DEFINED LOCAL_STATE_DIR)
  #set(LOCAL_STATE_DIR ${CMAKE_INSTALL_PREFIX}/var)
  set(LOCAL_STATE_DIR ${CMAKE_INSTALL_FULL_LOCALSTATEDIR})
endif(NOT DEFINED LOCAL_STATE_DIR)

# Where to install executables
if(NOT DEFINED BIN_INSTALL_DIR)
  #set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(BIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_BINDIR})
endif(NOT DEFINED BIN_INSTALL_DIR)

# Where to install system executables
if(NOT DEFINED SBIN_INSTALL_DIR)
  #set(BIN_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/bin)
  set(SBIN_INSTALL_DIR ${CMAKE_INSTALL_FULL_SBINDIR})
endif(NOT DEFINED SBIN_INSTALL_DIR)

# Where to install manual pages
if(NOT DEFINED MAN_INSTALL_DIR)
  #set(MAN_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/man)
  set(MAN_INSTALL_DIR ${CMAKE_INSTALL_FULL_MANDIR})
endif(NOT DEFINED MAN_INSTALL_DIR)

# Where to install documentation
if(NOT DEFINED DOC_INSTALL_DIR)
  #set(DOC_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/doc/svxlink)
  set(DOC_INSTALL_DIR ${CMAKE_INSTALL_FULL_DOCDIR})
endif(NOT DEFINED DOC_INSTALL_DIR)

# Where to install startup scripts
if(NOT DEFINED INIT_D_INSTALL_DIR)
  set(INIT_D_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/init.d)
endif(NOT DEFINED INIT_D_INSTALL_DIR)

# Where to install SvxLink config files
if(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)
  set(SVX_SYSCONF_INSTALL_DIR ${SYSCONF_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_SYSCONF_INSTALL_DIR)

# Where to install SvxLink spool files
if(NOT DEFINED SVX_SPOOL_INSTALL_DIR)
  set(SVX_SPOOL_INSTALL_DIR ${LOCAL_STATE_DIR}/spool/svxlink)
endif(NOT DEFINED SVX_SPOOL_INSTALL_DIR)

# Where to install SvxLink architecture independent files
if(NOT DEFINED SVX_SHARE_INSTALL_DIR)
  set(SVX_SHARE_INSTALL_DIR ${SHARE_INSTALL_PREFIX}/svxlink)
endif(NOT DEFINED SVX_SHARE_INSTALL_DIR)

# Where to install include files
if(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)
  set(SVX_INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_INCLUDE_INSTALL_DIR)

# Where to install SvxLink modules
if(NOT DEFINED SVX_MODULE_INSTALL_DIR)
  set(SVX_MODULE_INSTALL_DIR ${LIB_INSTALL_DIR}/svxlink)
endif(NOT DEFINED SVX_MODULE_INSTALL_DIR)


##############################################################################
# Functions
##############################################################################

# Create an include file under the global include directory
function(expinc filename)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${filename}
    ${PROJECT_INCLUDE_DIR}/${filename}
    COPYONLY
    )
endfunction(expinc)

# Add a target for building a version/xyz.h file
#
#   add_version_target(name [depends_var])
#
# The name of the version variable should be VER_name and the versions file
# will be named versions/name.h.
# If depends_var is given it will be set to a list of dependencies that the
# target using the versions file should add to its dependency list.
function(add_version_target name)
  set(depends_var ${ARGV1})
  if(DEFINED depends_var)
    set(${depends_var} ${${depends_var}}
      "${PROJECT_INCLUDE_DIR}/version/${name}.h"
      PARENT_SCOPE
      )
  endif(DEFINED depends_var)

  if(VER_${name})
    set(VERSION ${VER_${name}})
  else(VER_${name})
    set(VERSION "?.?.?")
  endif(VER_${name})

  add_custom_command(
    OUTPUT ${PROJECT_INCLUDE_DIR}/version/${name}.h
    WORKING_DIRECTORY ${PROJECT_INCLUDE_DIR}
    COMMAND ${CMAKE_COMMAND} -DVER_NAME=${name} -DVER_VALUE=${VERSION} 
                     -P ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
    DEPENDS ${CMAKE_SOURCE_DIR}/versions
            ${CMAKE_SOURCE_DIR}/cmake/create_version_include.cmake
  )
endfunction(add_version_target)

# Read a versions file and set up CMake variables for each entry
function(read_versions_file filename)
  message(STATUS "Reading versions file...")
  file(STRINGS ${filename} versions REGEX .*=.*)
  foreach(version ${versions})
    string(REGEX REPLACE \(.*\)=\(.*\) "VER_\\1;\\2" version ${version})
    set(${version} PARENT_SCOPE)
    if(version MATCHES ^VER_LIB)
      list(GET version 0 varname)
      list(GET version 1 varvalue)
      string(REGEX MATCH [0-9]+\\.[0-9]+ ${varname}_SOVERSION ${varvalue})
      set(${varname}_SOVERSION ${${varname}_SOVERSION} PARENT_SCOPE)
    endif(version MATCHES ^VER_LIB)
  endforeach(version)
endfunction(read_versions_file)

# Create a post install target to change the owner of an installed file.
# If DO_INSTALL_CHOWN is set to YES, the owner will be changed during
# installation.
# If DO_INSTALL_CHOWN is unset, the DESTDIR environment variable will be
# examined. If it is set, no chown operations will be performed since we are
# probably not running as a user with administrative rights. If DESTDIR is
# unset, chown operations are performed.
function(install_chown filename owner)
  if(owner)
    set(chown_commands "
      set(CHOWN_TOOL ${CHOWN_TOOL})
      if(NOT CHOWN_TOOL)
        MESSAGE(FATAL_ERROR \"Unable to find the 'chown' utility\")
      endif(NOT CHOWN_TOOL)
      set(full_filename \"\$ENV{DESTDIR}${filename}\")
      message(STATUS \"Setting owner of \${full_filename} to ${owner}...\")
      execute_process(
        COMMAND ${CHOWN_TOOL} ${owner} \"\${full_filename}\"
        RESULT_VARIABLE cmd_result
        )
      if(NOT \${cmd_result} EQUAL 0)
        MESSAGE(FATAL_ERROR
          \"Error while changing owner of file \${full_filename}\"
          )
      endif(NOT \${cmd_result} EQUAL 0)
      ")
    if(DEFINED DO_INSTALL_CHOWN)
      if(DO_INSTALL_CHOWN)
        install(CODE "${chown_commands}")
      endif(DO_INSTALL_CHOWN)
    else(DEFINED DO_INSTALL_CHOWN)
      install(CODE "
        if(\"\$ENV{DESTDIR}\" STREQUAL \"\")
          ${chown_commands}
        endif(\"\$ENV{DESTDIR}\" STREQUAL \"\")
        ")
    endif(DEFINED DO_INSTALL_CHOWN)
  endif(owner)
endfunction(install_chown)

# Create the given directory during installation
#   install_mkdir(directory [owner])
function(install_mkdir dir)
  set(owner ${ARGV1})
  get_filename_component(parent ${dir} PATH)
  file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir})
  install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}${dir} DESTINATION ${parent})
  install_chown(${dir} "${owner}")
endfunction(install_mkdir)

# Before installing the file, check if it exists. If it does, don't
# overwrite it.
#   install_if_not_exists(source_file destination_directory)
function(install_if_not_exists src dest)
  if(NOT IS_ABSOLUTE "${src}")
    set(src "${CMAKE_CURRENT_SOURCE_DIR}/${src}")
  endif()
  get_filename_component(src_name "${src}" NAME)
  if (NOT IS_ABSOLUTE "${dest}")
    set(dest "${CMAKE_INSTALL_PREFIX}/${dest}")
  endif()
  install(CODE "
    if(NOT EXISTS \"\$ENV{DESTDIR}${dest}/${src_name}\")
      #file(INSTALL \"${src}\" DESTINATION \"${dest}\")
      message(STATUS \"Installing: \$ENV{DESTDIR}${dest}/${src_name}\")
      execute_process(COMMAND \${CMAKE_COMMAND} -E copy \"${src}\"
                      \"\$ENV{DESTDIR}${dest}/${src_name}\"
                      RESULT_VARIABLE copy_result
                      ERROR_VARIABLE error_output)
      if(copy_result)
        message(FATAL_ERROR \${error_output})
      endif()
    else()
      message(STATUS \"Skipping  : \$ENV{DESTDIR}${dest}/${src_name}\")
    endif()
  ")
endfunction(install_if_not_exists)

##############################################################################
# Main execution starts here
##############################################################################

# Load the versions file and define version variables
read_versions_file(${PROJECT_SOURCE_DIR}/versions)

configure_file(${CMAKE_SOURCE_DIR}/config.h.in
  ${CMAKE_BINARY_DIR}/config.h
  @ONLY
  )

# Find the Sigc++ library
find_package(SIGC2 REQUIRED)

=== src/echolib/CMakeLists.txt ===
# Find the GSM codec library and include directory
find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

# Find Speex
# Do a quiet find here since the Async library already do a verbose find
find_package(Speex QUIET)
if(Speex_FOUND AND Speex_VERSION_MAJOR)
  include_directories(${Speex_INCLUDE_DIRS})
  add_definitions(${Speex_DEFINITIONS})
  add_definitions("-DSPEEX_MAJOR=${Speex_VERSION_MAJOR}")
  set(LIBS ${LIBS} ${Speex_LIBRARIES})
endif(Speex_FOUND AND Speex_VERSION_MAJOR)

set(LIBNAME echolib)

set(INSTALL_INC EchoLinkDirectory.h EchoLinkDispatcher.h EchoLinkQso.h
  EchoLinkStationData.h EchoLinkProxy.h)
set(EXPINC ${INSTALL_INC} rtp.h)

set(LIBSRC EchoLinkDirectory.cpp EchoLinkQso.cpp rtpacket.cpp
  EchoLinkDispatcher.cpp EchoLinkStationData.cpp EchoLinkProxy.cpp
  EchoLinkDirectoryCon.cpp md5.c)

set(LIBS ${LIBS} asynccore asyncaudio)

set(EXECUTABLES EchoLinkDispatcher_demo EchoLinkDirectory_demo
                EchoLinkQso_demo)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBECHOLIB}
  SOVERSION ${VER_LIBECHOLIB_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Find the popt library
find_package(Popt REQUIRED)
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Build applications
foreach(exe ${EXECUTABLES})
  add_executable(${exe} ${exe}.cpp)
  target_link_libraries(${exe} ${LIBS} echolib asynccpp asyncaudio asynccore)
endforeach(exe)

add_executable(echolib_test echolib_test.cpp EchoLinkQsoTest.cpp)
target_link_libraries(echolib_test ${LIBS} ${POPT_LIBRARIES} echolib asynccpp
                        asyncaudio asynccore)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${INSTALL_INC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/misc/CMakeLists.txt ===
set(LIBNAME svxmisc)
set(EXPINC common.h CppStdCompat.h)
set(LIBSRC common.cpp)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Build a static library
add_library(${LIBNAME} STATIC ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES OUTPUT_NAME ${LIBNAME})
target_link_libraries(${LIBNAME} ${LIBS})

# Install targets
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/qtel/CMakeLists.txt ===
# The program name
set(PROG qtel)

# Program source
set(PRGSRC qtel.cpp MainWindow.cpp ComDialog.cpp Settings.cpp MsgHandler.cpp
	   Vox.cpp EchoLinkDirectoryModel.cpp)

# Header files that need to be run through moc
set(QTHEADERS MainWindow.h ComDialog.h MyMessageBox.h Vox.h
	      SettingsDialog.h EchoLinkDirectoryModel.h)

# Forms that need to be run through uic
set(FORMS MainWindowBase.ui ComDialogBase.ui SettingsDialogBase.ui)            

# Resource files
set(RESOURCES qtel.qrc)

# Libraries
set(LIBS ${LIBS} echolib asyncqt asyncaudio asynccore svxmisc)

# Find the GSM codec library and include directory
find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

# Find Qt5
find_package(Qt5Core QUIET)
if (Qt5Core_FOUND)
  find_package(Qt5Gui REQUIRED)
  find_package(Qt5Widgets REQUIRED)
  find_package(Qt5Network REQUIRED)
  include_directories(${Qt5Core_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS}
                      ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
  set(LIBS ${LIBS} ${Qt5Core_LIBRARIES} ${Qt5Gui_LIBRARIES}
           ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES})

  # Generate targets for moc, uic and rcc
  QT5_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})
  QT5_WRAP_UI(FORMS_HEADERS ${FORMS})
  QT5_ADD_RESOURCES(RESOURCES_RCC ${RESOURCES})
endif()

# If not Qt5 was found, try Qt4
if (NOT Qt5Core_FOUND)
  find_package(Qt4 4.2 REQUIRED QtCore QtGui QtNetwork)
  include(${QT_USE_FILE})
  set(LIBS ${LIBS} ${QT_LIBRARIES})

  # Generate targets for moc, uic and rcc
  QT4_WRAP_CPP(QTHEADERS_MOC ${QTHEADERS})
  QT4_WRAP_UI(FORMS_HEADERS ${FORMS})
  QT4_ADD_RESOURCES(RESOURCES_RCC ${RESOURCES})
endif()

# We also need to add the current build directory to the include search path
# to find automatically generated h-files.
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Add targets for version files
set(VERSION_DEPENDS)
string(TOUPPER ${PROG} PROG_VERNAME)
add_version_target(${PROG_VERNAME} VERSION_DEPENDS)

# Compile the application
add_executable(${PROG} ${PRGSRC} ${QTHEADERS_MOC} ${FORMS_HEADERS}
  ${RESOURCES_RCC} ${VERSION_DEPENDS}
  )
target_link_libraries(${PROG} ${LIBS})
set_target_properties(${PROG} PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}  
  )

# Install targets
install(TARGETS ${PROG} DESTINATION ${BIN_INSTALL_DIR})
install(FILES connect.raw DESTINATION ${SHARE_INSTALL_PREFIX}/qtel/sounds)
install(FILES qtel.desktop DESTINATION ${SHARE_INSTALL_PREFIX}/applications)
install(FILES images/link.xpm DESTINATION ${SHARE_INSTALL_PREFIX}/icons)

# Build the translations subdirectory
add_subdirectory(translations)

=== src/async/audio/CMakeLists.txt ===
option(USE_ALSA "Alsa audio support" ON)
option(USE_OSS "OSS audio support" ON)

# Find Speex
find_package(Speex)
if(Speex_FOUND)
  if(DEFINED Speex_VERSION_MAJOR)
    include_directories(${Speex_INCLUDE_DIRS})
    add_definitions(${Speex_DEFINITIONS})
    add_definitions("-DSPEEX_MAJOR=${Speex_VERSION_MAJOR}")
    set(LIBS ${LIBS} ${Speex_LIBRARIES})
  else()
    message(WARNING
      "Found Speex but version could not be resolved. "
      "Will proceed without Speex.")
  endif()
else(Speex_FOUND)
  message("--   Speex is an optional dependency. The build will complete")
  message("--   without it but support for the Speex audio codec will")
  message("--   be unavailable.")
endif(Speex_FOUND)

# Find Opus
find_package(Opus)
if(Opus_FOUND)
  if(DEFINED Opus_VERSION_MAJOR)
    include_directories(${Opus_INCLUDE_DIRS})
    add_definitions(${Opus_DEFINITIONS})
    add_definitions("-DOPUS_MAJOR=${Opus_VERSION_MAJOR}")
    set(LIBS ${LIBS} ${Opus_LIBRARIES})
  else()
    message(WARNING
      "Found Opus but version could not be resolved. "
      "Will proceed without Opus.")
  endif()
else(Opus_FOUND)
  message("--   Opus is an optional dependency. The build will complete")
  message("--   without it but support for the Opus audio codec will")
  message("--   be unavailable.")
endif(Opus_FOUND)

find_package(GSM REQUIRED)
include_directories(${GSM_INCLUDE_DIR})
set(LIBS ${LIBS} ${GSM_LIBRARY})

set(LIBNAME asyncaudio)

set(EXPINC AsyncAudioSource.h AsyncAudioSink.h AsyncAudioProcessor.h
           AsyncAudioClipper.h AsyncAudioCompressor.h
           AsyncAudioFilter.h AsyncSigCAudioSink.h  AsyncSigCAudioSource.h
           AsyncAudioIO.h AsyncAudioSplitter.h AsyncAudioDelayLine.h
           AsyncAudioValve.h AsyncAudioAmp.h AsyncAudioSelector.h
           AsyncAudioPassthrough.h AsyncAudioMixer.h AsyncAudioFifo.h
           AsyncAudioDebugger.h AsyncAudioPacer.h AsyncAudioReader.h
           AsyncAudioDecimator.h AsyncAudioInterpolator.h
           AsyncAudioStreamStateDetector.h AsyncAudioEncoder.h
           AsyncAudioDecoder.h AsyncAudioRecorder.h
           AsyncAudioJitterFifo.h AsyncAudioDeviceFactory.h
           AsyncAudioDevice.h AsyncAudioNoiseAdder.h AsyncAudioGenerator.h
           AsyncAudioFsf.h)

set(LIBSRC AsyncAudioSource.cpp AsyncAudioSink.cpp
           AsyncAudioProcessor.cpp AsyncAudioCompressor.cpp
           AsyncAudioFilter.cpp fidlib.c AsyncAudioDevice.cpp
           AsyncAudioIO.cpp AsyncAudioSplitter.cpp
           AsyncAudioDelayLine.cpp AsyncAudioSelector.cpp
           AsyncAudioMixer.cpp AsyncAudioFifo.cpp AsyncAudioPacer.cpp
           AsyncAudioReader.cpp AsyncAudioDecimator.cpp
           AsyncAudioInterpolator.cpp AsyncAudioDecoder.cpp
           AsyncAudioEncoder.cpp AsyncAudioEncoderS16.cpp
           AsyncAudioDecoderS16.cpp AsyncAudioEncoderGsm.cpp
           AsyncAudioDecoderGsm.cpp AsyncAudioRecorder.cpp
           AsyncAudioDeviceFactory.cpp AsyncAudioJitterFifo.cpp
           AsyncAudioDeviceUDP.cpp AsyncAudioNoiseAdder.cpp
           AsyncAudioFsf.cpp)

if(Speex_FOUND)
  set(LIBSRC ${LIBSRC} AsyncAudioEncoderSpeex.cpp AsyncAudioDecoderSpeex.cpp)
endif(Speex_FOUND)

if(Opus_FOUND)
  set(LIBSRC ${LIBSRC} AsyncAudioEncoderOpus.cpp AsyncAudioDecoderOpus.cpp)
endif(Opus_FOUND)

if(USE_ALSA)
  set(LIBSRC ${LIBSRC} AsyncAudioDeviceAlsa.cpp)
  find_package(ALSA REQUIRED QUIET)
  set(LIBS ${LIBS} ${ALSA_LIBRARIES})
  include_directories(${ALSA_INCLUDE_DIRS})
endif(USE_ALSA)

if(USE_OSS)
  set(LIBSRC ${LIBSRC} AsyncAudioDeviceOSS.cpp)
endif(USE_OSS)

set(LIBS ${LIBS} asynccore)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Set up additional defines
add_definitions(-DT_LINUX)

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/async/cpp/CMakeLists.txt ===
set(LIBNAME asynccpp)

set(EXPINC AsyncCppApplication.h)

set(LIBSRC AsyncCppApplication.cpp AsyncCppDnsLookupWorker.cpp)

set(LIBS ${LIBS} asynccore)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Find pthreads
find_package(Threads)
set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})

# Set up additional defines
# FIXME: Do we need this?
add_definitions(-D_REENTRANT)

# Find librt
find_package(RT REQUIRED)
set(LIBS ${LIBS} ${RT_LIBRARIES})

# Build a shared library and a static library if configured
add_library(${LIBNAME} SHARED ${LIBSRC})
set_target_properties(${LIBNAME} PROPERTIES VERSION ${VER_LIBASYNC}
                      SOVERSION ${VER_LIBASYNC_SOVERSION})
target_link_libraries(${LIBNAME} ${LIBS})
if (BUILD_STATIC_LIBS)
  add_library(${LIBNAME}_static STATIC ${LIBSRC})
  set_target_properties(${LIBNAME}_static PROPERTIES OUTPUT_NAME ${LIBNAME})
  target_link_libraries(${LIBNAME}_static ${LIBS})
endif(BUILD_STATIC_LIBS)

# Install files
install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})
if (BUILD_STATIC_LIBS)
  install(TARGETS ${LIBNAME}_static DESTINATION ${LIB_INSTALL_DIR})
endif(BUILD_STATIC_LIBS)
install(FILES ${EXPINC} DESTINATION ${SVX_INCLUDE_INSTALL_DIR})

=== src/doc/man/CMakeLists.txt ===
# Set up which man pages to build and install
set(MAN_PAGES svxlink.1 svxlink.conf.5 remotetrx.1 remotetrx.conf.5
  siglevdetcal.1 devcal.1 svxreflector.1 svxreflector.conf.5 qtel.1
  ModuleHelp.conf.5 ModuleParrot.conf.5 ModuleEchoLink.conf.5
  ModuleTclVoiceMail.conf.5 ModuleDtmfRepeater.conf.5
  ModulePropagationMonitor.conf.5 ModuleSelCallEnc.conf.5
  ModuleFrn.conf.5 ModuleTrx.conf.5
)

# Search for the gzip and groff programs. Error out if not found.
include(FindGZIP)
include(FindGROFF)

# Set up a target for compressing each manual page. Also add an install
# target for it.
if(GROFF_TOOL AND GZIP_TOOL)
  set(TARGETS)
  foreach(man ${MAN_PAGES})
    add_custom_command(OUTPUT ${man}.gz
      DEPENDS ${man}
      COMMAND ${GZIP_TOOL} -c ${CMAKE_CURRENT_SOURCE_DIR}/${man} > ${man}.gz
      COMMENT "Compressing manual page ${man}.gz..."
    )
    add_custom_command(OUTPUT ${man}.html
      DEPENDS ${man}
      COMMAND ${GROFF_TOOL} -mandoc -Thtml < ${CMAKE_CURRENT_SOURCE_DIR}/${man} > ${man}.html
      COMMENT "Createing HTML manual page ${man}.html..."
    )
    string(REGEX REPLACE ^.*\([1-9]\)\$ \\1 sec ${man})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${man}.gz
      DESTINATION ${MAN_INSTALL_DIR}/man${sec}
      OPTIONAL
    )
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${man}.html
      DESTINATION ${DOC_INSTALL_DIR}/man/man${sec}
      OPTIONAL
    )
    set(TARGETS ${TARGETS} ${man}.gz ${man}.html)
  endforeach(man)

  # Add a custom target to trigger the build of the man pages
  add_custom_target(man DEPENDS ${TARGETS})
  add_dependencies(doc man)
else(GROFF_TOOL AND GZIP_TOOL)
  message("--   The groff and gzip tools are optional dependencies.")
  message("--   They are used to build the UNIX manual pages. SvxLink will")
  message("--   build without them but usage documentation will be missing.")
endif(GROFF_TOOL AND GZIP_TOOL)

=== src/svxlink/remotetrx/CMakeLists.txt ===
# Find the popt library
find_package(Popt REQUIRED)
set(LIBS ${LIBS} ${POPT_LIBRARIES})
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Find the GCrypt library
find_package(GCrypt REQUIRED)
set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
include_directories(${GCRYPT_INCLUDE_DIRS})
add_definitions(${GCRYPT_DEFINITIONS})

# Add project libraries
set(LIBS ${LIBS} trx asynccpp asyncaudio asynccore svxmisc)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(REMOTE_TRX VERSION_DEPENDS)

# Build the executable
add_executable(remotetrx
  TrxHandler.cpp Uplink.cpp NetUplink.cpp RfUplink.cpp
  NetTrxAdapter.cpp remotetrx.cpp
  ${VERSION_DEPENDS}
)
target_link_libraries(remotetrx ${LIBS})
set_target_properties(remotetrx PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}
)

# Install targets
install(TARGETS remotetrx DESTINATION ${BIN_INSTALL_DIR})
install_if_not_exists(remotetrx.conf ${SVX_SYSCONF_INSTALL_DIR})

=== src/svxlink/svxlink/CMakeLists.txt ===
# Find the popt library
find_package(Popt REQUIRED)
set(LIBS ${LIBS} ${POPT_LIBRARIES})
include_directories(${POPT_INCLUDE_DIRS})
add_definitions(${POPT_DEFINITIONS})

# Find the GSM codec library
find_package(GSM REQUIRED)
set(LIBS ${LIBS} ${GSM_LIBRARY})
include_directories(${GSM_INCLUDE_DIR})

# Find the TCL library
if(TCL_LIBRARY)
  set(TCL_LIBRARY_CACHED TRUE)
endif(TCL_LIBRARY)
find_package(TCL QUIET)
if(TCL_FOUND)
  if (NOT TCL_LIBRARY_CACHED)
    message("-- Found TCL: ${TCL_LIBRARY}")
  endif(NOT TCL_LIBRARY_CACHED)
else(TCL_FOUND)
  message(FATAL_ERROR "-- Could NOT find the TCL scripting language")
endif(TCL_FOUND)
set(LIBS ${LIBS} ${TCL_LIBRARY})
include_directories(${TCL_INCLUDE_PATH})

# Find the GCrypt library
find_package(GCrypt REQUIRED)
set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
include_directories(${GCRYPT_INCLUDE_DIRS})
add_definitions(${GCRYPT_DEFINITIONS})

# Find the dl library - only for Linux, not required for FreeBSD
if (${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  find_package(DL REQUIRED)
  set(LIBS ${LIBS} ${DL_LIBRARIES})
  include_directories(${DL_INCLUDES})
endif()

# Find libcurl libraries
FIND_PACKAGE(CURL)
if(CURL_FOUND)
   set(LIBS ${LIBS} ${CURL_LIBRARIES})
   set(LIBS ${LIBS} ${CURL_LIBRARY})
   set(CMAKE_REQUIRED_LIBRARIES "${CURL_LIBRARIES}")
   INCLUDE_DIRECTORIES(${CURL_INCLUDE_DIRS})
 else(CURL_FOUND)
   message(FATAL_ERROR "Could not find the CURL library and development files.")
endif(CURL_FOUND)

# Add project libraries
set(LIBS ${LIBS} trx locationinfo asynccpp asyncaudio asynccore svxmisc)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build the executable
add_executable(svxlink
  MsgHandler.cpp Module.cpp Logic.cpp SimplexLogic.cpp RepeaterLogic.cpp
  EventHandler.cpp LinkManager.cpp CmdParser.cpp QsoRecorder.cpp svxlink.cpp
  DtmfDigitHandler.cpp ReflectorLogic.cpp
  ${VERSION_DEPENDS}
)
target_link_libraries(svxlink ${LIBS})
set_target_properties(svxlink PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${RUNTIME_OUTPUT_DIRECTORY}
)

# Generate config file with correct paths
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/svxlink.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/svxlink.conf
  @ONLY
  )
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/gpio.conf.in
  ${CMAKE_CURRENT_BINARY_DIR}/gpio.conf
  @ONLY
  )
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/svxlink_gpio_up.in
	${RUNTIME_OUTPUT_DIRECTORY}/svxlink_gpio_up)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/svxlink_gpio_down.in
	${RUNTIME_OUTPUT_DIRECTORY}/svxlink_gpio_down)

# Install targets
install(TARGETS svxlink DESTINATION ${BIN_INSTALL_DIR})
install_mkdir(${SVX_SPOOL_INSTALL_DIR}/qso_recorder ${SVXLINK_USER}:${SVXLINK_GROUP})
install_mkdir(${SVX_SHARE_INSTALL_DIR}/sounds)
install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/svxlink.conf
  ${SVX_SYSCONF_INSTALL_DIR}
  )
install_if_not_exists(${CMAKE_CURRENT_BINARY_DIR}/gpio.conf
  ${SVX_SYSCONF_INSTALL_DIR}
  )
install(FILES events.tcl DESTINATION ${SVX_SHARE_INSTALL_DIR})
install(FILES RepeaterLogic.tcl SimplexLogic.tcl Module.tcl Logic.tcl CW.tcl
  SelCall.tcl locale.tcl
  DESTINATION ${SVX_SHARE_INSTALL_DIR}/events.d
  )
install(PROGRAMS ${RUNTIME_OUTPUT_DIRECTORY}/svxlink_gpio_up
  DESTINATION ${SBIN_INSTALL_DIR}
  )
install(PROGRAMS ${RUNTIME_OUTPUT_DIRECTORY}/svxlink_gpio_down
  DESTINATION ${SBIN_INSTALL_DIR}
  )

=== src/svxlink/systemd/CMakeLists.txt ===
#############################################################################
# SvxLink ROIP Repeater system Systemd setup
#############################################################################

set(SYSTEMD_CONFIGURATIONS_FILES_DIR "/lib/systemd/system" CACHE PATH
  "Path to systemd units")
set(SYSTEMD_DEFAULTS_FILES_DIR "${SYSCONF_INSTALL_DIR}/default" CACHE PATH
  "Path to systemd unit configuration files")

configure_file(svxlink_gpio_setup.service.in svxlink_gpio_setup.service @ONLY)
configure_file(svxlink.service.in svxlink.service @ONLY)
configure_file(remotetrx.service.in remotetrx.service @ONLY)
configure_file(svxreflector.service.in svxreflector.service @ONLY)
configure_file(svxlink.default.in svxlink @ONLY)
configure_file(remotetrx.default.in remotetrx @ONLY)
configure_file(svxreflector.default.in svxreflector @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/svxlink_gpio_setup.service
              ${CMAKE_CURRENT_BINARY_DIR}/svxlink.service
              ${CMAKE_CURRENT_BINARY_DIR}/remotetrx.service
              ${CMAKE_CURRENT_BINARY_DIR}/svxreflector.service
        DESTINATION ${SYSTEMD_CONFIGURATIONS_FILES_DIR})
message(STATUS "Systemd unit files will be installed to "
        "${SYSTEMD_CONFIGURATIONS_FILES_DIR} after make install")

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/svxlink
              ${CMAKE_CURRENT_BINARY_DIR}/remotetrx
              ${CMAKE_CURRENT_BINARY_DIR}/svxreflector
        DESTINATION ${SYSTEMD_DEFAULTS_FILES_DIR} )
message(STATUS "Systemd unit configuration files will be "
               "installed to ${SYSTEMD_DEFAULTS_FILES_DIR} "
               "after make install")

=== src/svxlink/trx/CMakeLists.txt ===
# The name of the library
set(LIBNAME trx)

# Which include files to export to the global include directory
set(EXPINC Rx.h Tx.h NetTrxMsg.h LocalRx.h Modulation.h)

# What sources to compile for the library
set(LIBSRC
  ToneDetector.cpp Dh1dmSwDtmfDecoder.cpp Rx.cpp LocalRx.cpp
  SquelchVox.cpp SigLevDetNoise.cpp NetRx.cpp Voter.cpp
  Tx.cpp LocalTx.cpp DtmfEncoder.cpp NetTx.cpp
  NetTrxTcpClient.cpp DtmfDecoder.cpp HwDtmfDecoder.cpp
  S54sDtmfDecoder.cpp PttCtrl.cpp MultiTx.cpp
  SigLevDetTone.cpp Sel5Decoder.cpp SwSel5Decoder.cpp
  SquelchEvDev.cpp Macho.cpp SquelchGpio.cpp Ptt.cpp
  PttGpio.cpp PttSerialPin.cpp PttPty.cpp
  PtyDtmfDecoder.cpp LocalRxBase.cpp Ddr.cpp RtlSdr.cpp RtlTcp.cpp
  WbRxRtlSdr.cpp SigLevDet.cpp SigLevDetDdr.cpp
  SvxSwDtmfDecoder.cpp LocalRxSim.cpp SigLevDetSim.cpp
  AfskDtmfDecoder.cpp SigLevDetAfsk.cpp Modulation.cpp
)
include (CheckSymbolExists)
CHECK_SYMBOL_EXISTS(HIDIOCGRAWINFO linux/hidraw.h HAS_HIDRAW_SUPPORT)
if (HAS_HIDRAW_SUPPORT)
  set (LIBSRC ${LIBSRC} PttHidraw.cpp SquelchHidraw.cpp)
  add_definitions(-DHAS_HIDRAW_SUPPORT)
endif (HAS_HIDRAW_SUPPORT)

# Which other libraries this library depends on
set(LIBS ${LIBS} digital)

# Copy exported include files to the global include directory
foreach(incfile ${EXPINC})
  expinc(${incfile})
endforeach(incfile)

# Find the GCrypt library
find_package(GCrypt REQUIRED)
set(LIBS ${LIBS} ${GCRYPT_LIBRARIES})
include_directories(${GCRYPT_INCLUDE_DIRS})
add_definitions(${GCRYPT_DEFINITIONS})

# Find rtl-sdr
find_package(RtlSdr)
if (RTLSDR_FOUND)
  set(LIBS ${LIBS} ${RTLSDR_LIBRARIES})
  include_directories(${RTLSDR_INCLUDE_DIRS})
  add_definitions(${RTLSDR_DEFINITIONS} -DHAS_RTLSDR_SUPPORT)
  set(LIBSRC ${LIBSRC} RtlUsb.cpp)

  # We also need pthreads when using the RtlUsb class
  find_package(Threads REQUIRED)
  set(LIBS ${LIBS} ${CMAKE_THREAD_LIBS_INIT})
  add_definitions(-D_REENTRANT)
else (RTLSDR_FOUND)
  message(
    "--   The rtl-sdr library is an optional dependency.\n"
    "--   Direct USB access to RTL2832u DVB-T/SDR dongles will be\n"
    "--   unavailable. Access through rtl_tcp will still work though."
  )
endif (RTLSDR_FOUND)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build only a static library
add_library(${LIBNAME} STATIC ${LIBSRC} ${VERSION_DEPENDS})
target_link_libraries(${LIBNAME} ${LIBS})

add_executable(DtmfDecoderTest DtmfDecoderTest.cpp)
target_link_libraries(DtmfDecoderTest ${LIBNAME} asynccore asyncaudio)

# Install targets
#install(TARGETS ${LIBNAME} DESTINATION ${LIB_INSTALL_DIR})

=== src/svxlink/modules/dtmf_repeater/CMakeLists.txt ===
# The name of the module without the Module prefix
set(MODNAME DtmfRepeater)

# Module source code
#set(MODSRC xyz.cpp)

# Project libraries to link to
#set(LIBS ${LIBS} echolib)

# The version tag name without the VER_ prefix
set(VERNAME ${MODNAME})
string(REGEX REPLACE \(.\)\([A-Z]\) \\1_\\2 VERNAME ${VERNAME})
string(TOUPPER MODULE_${VERNAME} VERNAME)

# Add targets for version files
set(VERSION_DEPENDS)
add_version_target(${VERNAME} VERSION_DEPENDS)
add_version_target(SVXLINK VERSION_DEPENDS)

# Build the plugin
add_library(Module${MODNAME} MODULE Module${MODNAME}.cpp ${MODSRC}
  ${VERSION_DEPENDS}
)
set_target_properties(Module${MODNAME} PROPERTIES PREFIX "")
set_property(TARGET Module${MODNAME} PROPERTY NO_SONAME 1)
target_link_libraries(Module${MODNAME} ${LIBS})

# Install targets
install(TARGETS Module${MODNAME} DESTINATION ${SVX_MODULE_INSTALL_DIR})
install(FILES ${MODNAME}.tcl DESTINATION ${SVX_SHARE_INSTALL_DIR}/events.d)
install_if_not_exists(Module${MODNAME}.conf
  ${SVX_SYSCONF_INSTALL_DIR}/svxlink.d
  )

=== debian/changelog ===
svxlink (19.09.1-2) unstable; urgency=medium

  * Source-only upload for migration to testing.
  * Bumped Standards-Version to 4.5.0.

 -- Felix Lechner <felix.lechner@lease-up.com>  Tue, 04 Feb 2020 13:54:32 -0800

svxlink (19.09.1-1) unstable; urgency=medium

  * New upstream release.
  * Added Build-Depends: libcurl4-gnutls-dev.
  * Refreshed patches.
  * Removed patch fixing gpio scripts incorporated upstream.
  * Switched to debhelper-compat in d/control instead of d/compat.
  * Bumped Standards-Version to 4.4.1,
  * Added Rules-Requires-Root: no to d/control.
  * Set shared object version to 1.6 for
      - libasynccore
      - libasyncqt
      - libasyncaudio
      - libasynccpp
  * Fix spelling in manpage for ModuleTrx.conf.

 -- Felix Lechner <felix.lechner@lease-up.com>  Sun, 05 Jan 2020 06:08:29 -0800

=== debian/control ===
Source: svxlink
Section: hamradio
Priority: optional
Maintainer: Felix Lechner <felix.lechner@lease-up.com>
Build-Depends-Indep: librsvg2-bin
Build-Depends:
 debhelper-compat (= 12),
 cmake,
 libcurl4-gnutls-dev,
 libsigc++-2.0-dev (>= 2.2.10-0.2),
 libpopt-dev,
 libgcrypt-dev,
 libgsm1-dev,
 libspeex-dev,
 libopus-dev,
 libasound2-dev,
 librtlsdr-dev,
 qtbase5-dev,
 qttools5-dev,
 tk-dev,
 doxygen
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://www.svxlink.org

Package: svxlink-server
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 svxlink-gpio (= ${source:Version}),
 adduser,
 lsb-base (>= 3.0-6)
Recommends:
 remotetrx (= ${binary:Version}),
 svxlink-calibration-tools (= ${binary:Version})
Description: Voice-over-IP server for ham radio operators
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. It can act as a repeater controller
 or operate on a simplex channel. Based on a modular design, the server
 can be configured to provide voice mail and echo (talkback) service.
 It is normally used together with the 'remotetrx' package, which allows
 the remote control of a radio transceiver.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: svxreflector
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 adduser,
 lsb-base (>= 3.0-6)
Description: Conference server for SvxLink amateur radio servers
 The SvxReflector can interconnect multiple SvxLink nodes. Audio sent to
 the reflector is broadcast to all other nodes. Only one talker is
 allowed at a time.
 .
 For a client program implementing the EchoLink® protocol, please
 have a look at the 'qtel' package.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: remotetrx
Architecture: linux-any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 svxlink-gpio (= ${source:Version}),
 adduser,
 lsb-base (>= 3.0-6)
Recommends:
 svxlink-server (= ${binary:Version}),
 svxlink-calibration-tools (= ${binary:Version})
Description: Remote controller for radio transceivers
 The RemoteTrx server facilitates remote control of amateur radio
 transceivers via the EchoLink® protocol. It is normally
 used together with the 'svxlink-server' package, which allows
 for nearly world-wide access from the Internet.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver. EchoLink® is a registered trademark of
 Synergenics, LLC.

Package: svxlink-gpio
Architecture: all
Depends: ${misc:Depends}
Description: GPIO control scripts SvxLink amateur radio server
 This package contains the GPIO control scripts for general purpose I/O
 for the SvxLink suite. SvxLink provides access to a ham radio
 transceiver via the EchoLink® protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 By connecting into a server connected to a repeater, an operator
 can call into a local radio net via the Internet while traveling
 out of the area. EchoLink® is a registered trademark of
 Synergenics, LLC.

Package: svxlink-calibration-tools
Architecture: linux-any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: svxlink-server (<< 17.12.1-1)
Replaces: svxlink-server (<< 17.12.1-1)
Description: Calibration tools for SvxLink amateur radio suite
 SvxLink facilitates remote control of amateur radio transceivers via the
 EchoLink® protocol. This package included the calibration tools.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 The RemoteTrx server provides remote control of a connected radio
 transceiver. EchoLink® is a registered trademark of
 Synergenics, LLC.

Package: qtel
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, qtel-icons
Description: Graphical client for the EchoLink® protocol
 Qtel is a graphical client program for the EchoLink® ham radio
 protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: qtel-icons
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Icons for graphical client for the EchoLink® protocol
 Icons for Qtel, a graphical client program for the EchoLink®
 ham radio protocol.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp1.6
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncCpp library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the AsyncCpp
 library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccpp-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libasynccpp1.6 (= ${binary:Version})
Description: AsyncCpp library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the static
 version and the header files for the AsyncCpp library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio1.6
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncAudio library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the AsyncAudio
 library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncaudio-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libasyncaudio1.6 (= ${binary:Version})
Description: AsyncAudio library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the static
 version and the header files for the AsyncAudio library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncqt1.6
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncQt library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.  This package contains the AsyncQt
 library for event-driven Qt applications using the Async classes.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasyncqt-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libasyncqt1.6 (= ${binary:Version})
Description: AsyncQt library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the static
 version and the header files for the AsyncQt library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccore1.6
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AsyncCore library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the AsyncCore
 library for event-driven applications that use Async classes.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libasynccore-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libasynccore1.6 (= ${binary:Version})
Description: AsyncCore library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol. This package contains the static
 version and the header files for the AsyncCore library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib1.3
Architecture: linux-any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: EchoLib library for SvxLink
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.  This package contains EchoLib, a
 library for EchoLink communications.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

Package: libecholib-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libecholib1.3 (= ${binary:Version})
Description: EchoLib library for SvxLink (development files)
 The SvxLink server provides access to a ham radio transceiver via
 the EchoLink® protocol.  This package contains the static
 version and the header files for the EchoLib library.
 .
 EchoLink® allows licensed amateur radio operators to communicate
 over the Internet, including remote access to station equipment.
 EchoLink® is a registered trademark of Synergenics, LLC.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

#CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
#CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
#CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
#LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT=qt5

%:
	dh $@ \
		--buildsystem=cmake \
		--sourcedirectory=src \
		--builddirectory=build \

.PHONY: override_dh_auto_configure
override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		-DWITH_SYSTEMD=ON \
		-DBUILD_STATIC_LIBS=ON \
		-DSYSCONF_INSTALL_DIR=/etc \
		-DLOCAL_STATE_DIR=/var

.PHONY: override_dh_auto_build-indep
override_dh_auto_build-indep:
	mkdir -p $(CURDIR)/debian/icons/generated/64x64/
	rsvg-convert --width 64 --keep-aspect-ratio $(CURDIR)/debian/icons/original/Transmission-3-edited-recolored.svg > $(CURDIR)/debian/icons/generated/64x64/qtel.png
	mkdir -p $(CURDIR)/debian/icons/generated/128x128/
	rsvg-convert --width 128 --keep-aspect-ratio $(CURDIR)/debian/icons/original/Transmission-3-edited-recolored.svg > $(CURDIR)/debian/icons/generated/128x128/qtel.png
	mkdir -p $(CURDIR)/debian/icons/generated/256x256/
	rsvg-convert --width 256 --keep-aspect-ratio $(CURDIR)/debian/icons/original/Transmission-3-edited-recolored.svg > $(CURDIR)/debian/icons/generated/256x256/qtel.png
	dh_auto_build --indep

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	find $(CURDIR) -name 'moc_*' -execdir rm -fv '{}' \;
	find $(CURDIR) -name 'qrc_*' -execdir rm -fv '{}' \;
	-rm $(CURDIR)/debian/icons/generated/64x64/qtel.png
	-rm $(CURDIR)/debian/icons/generated/128x128/qtel.png
	-rm $(CURDIR)/debian/icons/generated/256x256/qtel.png
	dh_auto_clean

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip -psvxlink-server
	dh_strip -premotetrx
	dh_strip -pqtel
	dh_strip -plibecholib1.3
	dh_strip -plibasynccore1.6
	dh_strip -plibasynccpp1.6
	dh_strip -plibasyncaudio1.6
	dh_strip -plibasyncqt1.6
	dh_strip

.PHONY: override_dh_installinit
override_dh_installinit:
	dh_installinit -psvxlink-server --name=svxlink
	dh_installinit

.PHONY: override_dh_installchangelogs
override_dh_installchangelogs:
	dh_installchangelogs -psvxlink-server src/svxlink/ChangeLog
	dh_installchangelogs -psvxreflector src/svxlink/ChangeLog
	dh_installchangelogs -premotetrx src/svxlink/ChangeLog
	dh_installchangelogs -psvxlink-gpio src/svxlink/ChangeLog
	dh_installchangelogs -psvxlink-calibration-tools src/svxlink/ChangeLog
	dh_installchangelogs -pqtel src/qtel/ChangeLog
	dh_installchangelogs -pqtel-icons src/qtel/ChangeLog
	dh_installchangelogs -plibecholib1.3 src/echolib/ChangeLog
	dh_installchangelogs -plibecholib-dev src/echolib/ChangeLog
	dh_installchangelogs -plibasynccore1.6 src/async/ChangeLog
	dh_installchangelogs -plibasynccore-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio1.6 src/async/ChangeLog
	dh_installchangelogs -plibasyncaudio-dev src/async/ChangeLog
	dh_installchangelogs -plibasynccpp1.6 src/async/ChangeLog
	dh_installchangelogs -plibasynccpp-dev src/async/ChangeLog
	dh_installchangelogs -plibasyncqt1.6 src/async/ChangeLog
	dh_installchangelogs -plibasyncqt-dev src/async/ChangeLog

#.PHONY: override_dh_fixperms
#override_dh_fixperms:
#	dh_fixperms
#	chmod a-x debian/svxlink-server/etc/default/svxlink
#	chmod a-x debian/remotetrx/etc/default/remotetrx

=== debian/watch ===
version=3

# Svxlink on GitHub
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/svxlink-$1\.tar\.gz/ \
  https://github.com/sm0svx/svxlink/releases .*/(\d+(?:\.\d+)+)\.tar\.gz
